<?php
require_once('r53.php');
require_once('IncR53.php');
$r53 = new Route53($awsid, $awskey);

function getPublicIP() { 
  // create a new cURL resource
  $ch = curl_init();

  // set URL and other appropriate options
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_HEADER, 0);
  curl_setopt($ch, CURLOPT_URL, "http://icanhazip.com");

  // grab URL and pass it to the browser
  $ip = curl_exec($ch);

  // close cURL resource, and free up system resources
  curl_close($ch);
  $ip = trim(preg_replace('/\s+/', ' ', $ip));
  return $ip;
}

function updateIP ($hostname, $newIP, $oldIP, $type = 'A', $ttl = 60) {
  global $r53, $awshosted;
  $delete = $r53->prepareChange('DELETE', $hostname, $type, $ttl, $oldIP);
  $result = $r53->changeResourceRecordSets('/hostedzone/'.$awshosted, $delete);
  $create = $r53->prepareChange('CREATE', $hostname, $type, $ttl, $newIP);
  $result = $r53->changeResourceRecordSets('/hostedzone/'.$awshosted, $create);
  print_r($result);
}

$recordSet 	= $r53->listResourceRecordSets('/hostedzone/'.$awshosted);
$newIP 		= getPublicIP();

$oldIP		= '';
$type  		= '';
$ttl   		= '';
foreach($hostname as $host) {
	for ($i = 0; $i < count($recordSet['ResourceRecordSets']); $i++) {
		if ($recordSet['ResourceRecordSets'][$i]['Name'] == $host) {
			echo '<p>'.$recordSet['ResourceRecordSets'][$i]['Name'].'</p>';
			$oldIP = $recordSet['ResourceRecordSets'][$i]['ResourceRecords'][0];
			$type  = $recordSet['ResourceRecordSets'][$i]['Type'];
			$ttl   = $recordSet['ResourceRecordSets'][$i]['TTL'];

			if ($oldIP !== $newIP && !empty($type) && !empty($ttl)) {
				echo '<p>'."Updating IP from ".$oldIP." to ".$newIP.'</p><p>';
				updateIP($host, $newIP, $oldIP, $type, $ttl);
				echo '</p>';
			}
		}
	}
}
?>